
#include <stdio.h>
#include <stdlib.h>
/* #include <linux/acct.h> */
#include "dissect-pacct.h"
#include <math.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
/* #include <linux/acct.h> */

#define	MANTSIZE	13			/* 13 bit mantissa. */
#define	EXPSIZE		3			/* Base 8 (3 bit) exponent. */
double comp_t_to_float(comp_t input_value)
{
	double output_value;
	double exponent;
	double mantissa;
	/* this mantissa is the low 13 bits, and the exponent is the high 3 bits of this 16 bit quantity */
	exponent = (input_value & 0xe0) >> MANTSIZE;
	mantissa = input_value & 0x1fff;
	/* this expression is a little iffy - Fri Feb 16 13:01:43 PST 2007 */
	output_value = (mantissa / pow(2, MANTSIZE)) * pow(8, exponent);
	return output_value;
}

char *gimme_time(time_t t)
	{
	static char string[1024];
	int length;
	strcpy(string, ctime(&t));
	length = strlen(string);
	if (string[length-1] == '\n')
		{
		string[length-1] = '\0';
		}
	return string;
	}

void display_header(void)
	{
	int retval;
	retval = printf("flag|version|tty|exitcode|uid|gid|pid|ppid|btime|human btime|etime|utime|stime|mem|io|rw|minflt|majflt|swaps|comm\n");
	if (retval < 0)
		{
		perror("header printf failed");
		exit(1);
		}
	}

void display_acct(struct acct_v3 *acct_struct)
	{
	int retval;
	retval = printf("%d|%d|%d|%d|%d|%d|%d|%d|%d|%s|%f|%f|%f|%f|%f|%f|%f|%f|%f|%s\n",
		acct_struct->ac_flag,
		acct_struct->ac_version,
		acct_struct->ac_tty,
		acct_struct->ac_exitcode,
		acct_struct->ac_uid,
		acct_struct->ac_gid,
		acct_struct->ac_pid,
		acct_struct->ac_ppid,
		acct_struct->ac_btime,
		gimme_time(acct_struct->ac_btime),
		acct_struct->ac_etime / 100.0, /* this divide-by-100 was determined empirically */
		comp_t_to_float(acct_struct->ac_utime),
		comp_t_to_float(acct_struct->ac_stime),
		comp_t_to_float(acct_struct->ac_mem),
		comp_t_to_float(acct_struct->ac_io),
		comp_t_to_float(acct_struct->ac_rw),
		comp_t_to_float(acct_struct->ac_minflt),
		comp_t_to_float(acct_struct->ac_majflt),
		comp_t_to_float(acct_struct->ac_swaps),
		acct_struct->ac_comm);
	if (retval < 0)
		{
		perror("header printf failed");
		exit(1);
		}
	}

int main()
	{
	/* this does appear to be the right struct, based on a division */
	struct acct_v3 acct_struct;
	unsigned char acct_char[sizeof(struct acct_v3)];
	FILE *file;
	/* int i; */
	file = fopen("/var/log/pacct", "r");
	if (file == NULL)
		{
		perror("opening /var/log/pacct failed");
		exit(1);
		}
	display_header();
	/* exit(0); */
	while (!feof(file) && !ferror(file))
		{
		int num_read;
		num_read = fread((void *)&acct_struct, (size_t)1, sizeof(acct_struct), file);
		if (num_read == 0)
			{
			break;
			}
		if (num_read != sizeof(acct_char))
			{
			fprintf(stderr, "got %d bytes, wanted %u bytes \n", num_read, (unsigned int)sizeof(acct_char));
			/* fprintf(stderr, "got %d bytes, wanted %u bytes \n", num_read, 64); */
			perror("fread /var/log/pacct failed");
			exit(1);
			}
		/* char_array_to_struct_acct(acct_char, &acct_struct); */
		display_acct(&acct_struct);
		}
	if (ferror(file))
		{
		perror("fread failed");
		exit(1);
		}
	if (fclose(file) != 0)
		{
		perror("fclose /var/log/pacct failed");
		exit(1);
		}
	return 0;
	}

